$(document).ready( function () {
    var hideCls = 'collapsed',
        selectedCls = 'nav-selected',
        groups = $('.nav-group'),
        currentPage = $(location).attr('pathname'),
        currentNode;

    currentPage = currentPage.substr(currentPage.lastIndexOf('/') + 1);
    currentNode = $("li > a[href='" + currentPage + "']");

    //Expand all groups in which the current page sits
    currentNode.parents('.nav-group').removeClass(hideCls);

    //If a node has been selected then mark it as selected
    if (currentNode.parent().hasClass('nav-node')) {
        currentNode.addClass(selectedCls);
    }

    groups.unbind('click').click(function (event) {
        var selected = $(this),
            isCollapsed = selected.hasClass(hideCls),
            currentPage = $(location).attr('pathname');

        if (this === event.target.parentElement) {
            //Collapse all groups except the parents
            //of the selected group
            $('.nav-group').addClass(hideCls);
            selected.parents('.nav-group').removeClass(hideCls);

            //Toggle the selected group
            if (isCollapsed) {
                selected.removeClass(hideCls);
            } else {
                selected.addClass(hideCls);
            }

            //If the link takes us to another page then return true so that we can navigate away.
            currentPage = currentPage.substr(currentPage.lastIndexOf('/') + 1);
            href = selected.children('a').attr('href');
            return href !== '.' && href !== currentPage;
        }
    });
});
