var tipuesearch = {"pages" : [{"title": "Assignments","text": " Inserts or updates time off request details as an assignment record. <br/><br/> <em style=\"font-weight: bold; font-style: normal\" class=\"helpHead4\"> Request Keys </em> <br/><br/> The following keys are available to use for the time off to assignment integration.<br/> <ol> <li><em> CorrelationId </em>\u0009-\u0009The assignment's unique identifier that links it to a time off request in a third-party HCM application. </li> <li><em> ResourceCorrelationId </em>\u0009-\u0009The resource's unique identifier that links them to a third-party HCM application. </li> <li><em> RequestStatus </em>\u0009-\u0009The status of the time off request, such as Approved or Canceled. </li> <li><em> RequestDates </em>\u0009\u0009-\u0009Details of each date in the time off request. <li><em> Date </em>\u0009\u0009-\u0009The individual date in the time off request. </li> <li><em> DateStatus </em>\u0009-\u0009The status of the date, such as Approved or Canceled. </li> <li><em> Policy </em>\u0009-\u0009The policy associated with the date. </li> <li><em> Unit </em>\u0009\u0009-\u0009The unit of measurement associated with the date, such as days or hours. </li> <li><em> Quantity </em>\u0009\u0009-\u0009The amount of time off requested for the date. </li> </li> </ol> You must use the date format YYYY-MM-DD, such as 2018-04-24. <br/><br/> <em style=\"font-weight: bold; font-style: normal\" class=\"helpHead4\"> Response Keys </em> <br/><br/> The following keys are used in the response.<br/> <ol> <li><em> CorrelationId </em>\u0009-\u0009The assignment's unique identifier that links it to a time off request in a third-party HCM application. </li> <li><em> Message </em>\u0009-\u0009The message returned when an error occurs in a processing request. </li> </ol>","tags": "dopatch dopost","url": "Assignments.htm"},
{"title": "Resources","text": " Inserts or updates resource details as a contact or person account record. <br/><br/> <em style=\"font-weight: bold; font-style: normal\" class=\"helpHead4\"> Request Keys </em> <br/><br/> The following keys are available to use for the worker to resource integration.<br/> <ol> <li><em> CorrelationId </em>\u0009-\u0009The resource's unique identifier that links them to a third-party HCM application. </li> <li><em> LastName </em> \u0009- \u0009The resource's last name. </li> <li><em> Salutation </em> \u0009- \u0009The resource's salutation that indicates their profession or marital status. </li> <li><em> FirstName </em> \u0009- \u0009The resource's first name. </li> <li><em> Street </em>  \u0009- \u0009The street details of the resource's address. </li> <li><em> City </em> \u0009- \u0009The city details of the resource's address. </li> <li><em> StateOrProvince </em>  \u0009- \u0009The state or province details of the resource's address. </li> <li><em> PostalCode </em>  \u0009- \u0009The postal code or ZIP code of the resource's address. </li> <li><em> Country </em> \u0009- \u0009The country details of the resource's address. </li> <li><em> Phone </em> \u0009- \u0009The resource's phone number. </li> <li><em> MobilePhone </em> \u0009- \u0009 The resource's mobile phone number. </li> <li><em> Email </em> \u0009- \u0009The resource's email address. </li> <li><em> BusinessTitle </em> \u0009- \u0009 The resource's business title. </li> <li><em> ReportsTo </em> \u0009- \u0009 The resource's manager. This key is only available when creating resources as contacts.</li> <li><em> ExternalResource </em> \u0009- \u0009 Indicates that the resource is external to the organization, such as a contractor. </li> <li><em> CostCenter </em> \u0009- \u0009 The resource's cost center in the organization structure.\u0009</li> <li><em> Department </em> \u0009- \u0009 The resource's department in the organization structure. </li> <li><em> Division </em> \u0009- \u0009 The resource's division in the organization structure.\u0009</li> <li><em> Location </em> \u0009- \u0009 The resource's location in the organization structure.\u0009</li> <li><em> ResourceStatus </em> \u0009- \u0009 The resource's employment status.\u0009</li> <li><em> ResourceStatusEffectiveDate </em> \u0009- \u0009 The date the resource's employment status becomes effective.</li> <li><em> ResourceRole </em> \u0009- \u0009 The resource's role.\u0009</li> <li><em> WorkCalendar </em> \u0009- \u0009 The resource's work calendar.\u0009</li> <li><em> CustomField1 </em> \u0009- \u0009 Additional information. </li> <li><em> CustomField2 </em> \u0009- \u0009 Additional information. </li> <li><em> CustomField3 </em> \u0009- \u0009 Additional information. </li> <li><em> CustomField4 </em> \u0009- \u0009 Additional information. </li> <li><em> CustomField5 </em> \u0009- \u0009 Additional information. </li> <li><em> CustomField6 </em> \u0009- \u0009 Additional information. </li> <li><em> CustomField7 </em> \u0009- \u0009 Additional information. </li> <li><em> CustomField8 </em> \u0009- \u0009 Additional information. </li> <li><em> CustomField9 </em> \u0009- \u0009 Additional information. </li> <li><em> CustomField10 </em> \u0009- \u0009 Additional information. </li> <li><em> CustomField11 </em> \u0009- \u0009 Additional information. </li> <li><em> CustomField12 </em> \u0009- \u0009 Additional information. </li> <li><em> CustomField13 </em> \u0009- \u0009 Additional information. </li> <li><em> CustomField14 </em> \u0009- \u0009 Additional information. </li> <li><em> CustomField15 </em> \u0009- \u0009 Additional information. </li> </ol> You must use the date format YYYY-MM-DD, such as 2018-04-24. <br/><br/> <em style=\"font-weight: bold; font-style: normal\" class=\"helpHead4\"> Response Keys </em> <br/><br/> The following keys are used in the response.<br/> <ol> <li><em> CorrelationId </em>\u0009-\u0009The resource's unique identifier that links them to a third-party HCM application. </li> <li><em> Message </em>\u0009-\u0009The message returned when an error occurs in a processing request. </li> </ol>","tags": "dopatch dopost","url": "Resources.htm"},
{"title": "Timecards","text": " Enables you to get timecard details. <br/><br/> <em style=\"font-weight: bold; font-style: normal\" class=\"helpHead4\"> Request Keys </em> <br/><br/> The following keys are available to use for the timecard to payroll integration.<br/> <ol> <li><em> StartDate </em>\u0009-\u0009Start date of the date range for timecards. You must only use this key in the initial request. </li> <li><em> EndDate </em> \u0009-  End date of the date range for timecards. You must only use this key in the initial request. </li> <li><em> CorrelationIds </em> \u0009-  List of unique worker IDs in the HCM system. You must only use this key in the initial request. </li> <li><em> BatchLimit </em>\u0009-\u0009Maximum number of resources we can send timecards for in a single response. You must only use this key in the initial request. If no value is specified in the request, the default BatchLimit value of 120 applies. </li> <li><em> TimecardTransmissionId </em>\u0009-\u0009Salesforce ID of the Timecard Transmission object. This parameter is optional. If it is not included in a request, the request will be treated as an initial request. </li> </ol> You must use the date format YYYY-MM-DD, such as 2018-04-24. <br/><br/> <em style=\"font-weight: bold; font-style: normal\" class=\"helpHead4\"> Response Keys </em> <br/><br/> The following keys are used in the response.<br/> <ol> <li><em> NextPageRequest </em>\u0009-\u0009Used to get the next chunk of timecard details for a transmission. </li> <li><em> TimecardTransmissionId </em>\u0009-\u0009Salesforce ID of the Timecard Transmission object. If this key exists in the POST response, a further request is required to get the timecards for another resource. If this key is not present in the POST response, no further request is needed. </li> <li><em> Timecards </em>\u0009-\u0009The list of returned timecards that fall within the specified date range. </li> <li><em> CorrelationId </em>\u0009-\u0009Unique worker ID from the HCM system. </li> <li><em> EarningsCode </em>\u0009-\u0009Name of the earnings code, for example, VAC. </li> <li><em> TimeEntryDetails </em>\u0009-\u0009The list of all timecard dates with values for a given date range, grouped by project. </li> <li><em> TimeEntryDate </em>\u0009-\u0009Timecard date, using ISO-8601 format YYYY-MM-DD. </li> <li><em> Hours </em>\u0009-\u0009Number of approved hours in the timecard date in Number(2, 2) format. </li> <li><em> Message </em>\u0009-\u0009The message returned when an error occurs in a processing request. </li> </ol>","tags": "dopost","url": "Timecards.htm"}]};
